/***************************************************/
/* Game Excelleration Kit vX                       */
/* Copyright (C) 2001 by HourGlass Software NonInc */
/***************************************************/
#ifndef __GEKCurve__
#define __GEKCurve__
/*! 
	\author MoJo
    \file GEKCurve.h
    \brief Curve Calculation
*/

#include <math.h>

template <class CLASS>
CLASS GEKXBernstein(float fFactor, CLASS *pkBase)
{
	CLASS kA(pkBase[0] * powf(fFactor, 3.0f));
	CLASS kB(pkBase[1] * (3.0f * powf(fFactor, 2.0f) * (1.0f - fFactor)));
	CLASS kC(pkBase[2] * (3.0f * fFactor * powf((1.0f - fFactor), 2.0f)));
	CLASS kD(pkBase[3] * powf((1.0f - fFactor), 3.0f));
	return ((kA + kB) + (kC + kD));
}

#endif